''
'' VGA display 50xH (single cog) - demo
''
'' Quick Demo By Jeff Ledger
CON

   _clkmode  = xtal1 + pll16x
   _xinfreq  = 5_000_000

BLACK           = 0
AQUA            = 40
BLUE            = 12
NAVY            = 7
ROYALBLUE       = 88
SKYBLUE         = 111
HOTPINK         = 200
LAWNGREEN       = 100
ORANGE          = 144
YELLOW          = 240
PEACH           = 148
WHITE           = 254
DARKGRAY        = 87
RED             = 128
PALEYELLOW      = 164
PURPLE          = 136
GREEN           = 98
CYAN            = 127
KHAKI           = 180
OLIVE           = 83
CRIMSON         = 135
PINK            = 199
OFFWHITE        = 232
CHOCOLATE       = 148
MISTYROSE       = 168
SALMON          = 212
DARKSLATE       = 23
YELLOWORANGE    = 224


OBJ
     vga: "50xH_ui"
  
VAR
  long  palette[vga#bcnt_raw / 2]                       ' 4n aligned for rdlong
  
PUB selftest | c,xx,yy

  vga.init
 
  vga.str(string(vga#ESC, "s"))            
  vga.setn(2, @palette{0})
 

    vga.backcolor(BLACK)
    vga.cls
    
    vga.textcolor(BLACK)    
    vga.backcolor(HOTPINK)
    vga.str(string("THE QUICK BROWN FOX JUMPED OVER THE LAZY POODLE.",13))
    vga.backcolor(RED)
    vga.str(string("THE QUICK BROWN FOX JUMPED OVER THE LAZY POODLE.",13))
    vga.backcolor(YELLOW)
    vga.str(string("THE QUICK BROWN FOX JUMPED OVER THE LAZY POODLE.",13))
    vga.str(string("THE QUICK BROWN FOX JUMPED OVER THE LAZY POODLE.",13))
    vga.str(string("THE QUICK BROWN FOX JUMPED OVER THE LAZY POODLE.",13))
    vga.str(string("THE QUICK BROWN FOX JUMPED OVER THE LAZY POODLE.",13))
    vga.str(string("THE QUICK BROWN FOX JUMPED OVER THE LAZY POODLE.",13))
    vga.str(string("THE QUICK BROWN FOX JUMPED OVER THE LAZY POODLE.",13))
    vga.str(string("THE QUICK BROWN FOX JUMPED OVER THE LAZY POODLE.",13)) 
    vga.backcolor(black)
    vga.textcolor(red)
 
    vga.redefine_plot
  repeat
    repeat vga#bcnt_raw * 5
      vga.backcolor(c)
      vga.plot(||(?xx//(vga#columns*2)), ||(yy?//(vga#rows*2)), c)
      c++
    repeat vga#bcnt_raw * 5
      vga.plot(||(?xx//(vga#columns*2)), ||(yy?//(vga#rows*2)), -1)
    waitcnt(clkfreq + cnt)
  